Attribute VB_Name = "Globals"
Option Explicit

Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long

Public Const g_APPNAME As String = "MyProduct"

Public ExitApp As Boolean

' The product serial number. This could
' be burned onto the disk, although that's
' problematic if you are mass duplicating.
' Another option would be to print it on
' the packaging and make the user enter it
' the first time it's run.
Private Const m_PRODUCT_SERIAL As String = "1234567890"
' Return a combined product and disk serial number
' of the form 11111111112222222222.
Public Function GetCombinedSerialNumber() As String
    GetCombinedSerialNumber = _
        Format$(m_PRODUCT_SERIAL, "0000000000") & _
        Format$(GetDiskSerialNumber(), "0000000000")
End Function

' Return the disk's serial number
' as a 10-digit string.
Private Function GetDiskSerialNumber() As String
Static serial_number As Long

Dim volume_name As String
Dim max_component_length As Long
Dim file_system_flags As Long
Dim file_system_name As String

    If serial_number = 0 Then
        ' Get the disk serial number.
        volume_name = Space$(1024)
        file_system_name = Space$(1024)
        If GetVolumeInformation(vbNullString, _
            volume_name, Len(volume_name), _
            serial_number, _
            max_component_length, file_system_flags, _
            file_system_name, Len(file_system_name)) = 0 _
        Then
            MsgBox "Error getting system information."
            GetDiskSerialNumber = 0
            Exit Function
        End If
    End If

    GetDiskSerialNumber = Format$(serial_number, "0000000000")
End Function
